/*
 * mem2bgl.c
 *
 * yn@ ln} 50m bV(W)f[^A
 * FS2000 SDK ɕϊ
 */
/* $Id: mem2bgl.c,v 1.3 2001/12/03 17:11:04 tmurakam Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

#include "wgstko.h"

double glatmin = 10000;
double glatmax = -10000;
double glonmin = 10000;
double glonmax = -10000;
int thinout	= 1;
int latlon_specified = 0;
int keep = 0;

static int analyze(int count, FILE *ifp, FILE *mfp, FILE *rfp, char *rawfile);
static void process_memfile(FILE *ifp, char *memfile, int *nsrc);

/*
 * main
 */
int
main(int argc, char *argv[])
{
	char *bglfile, *lod, *filelist;
	int narg, nsrc;
	FILE *ifp;
	char comline[100];

	if (argc < 3) {
		fprintf(stderr, "Usage: %s [option] <bgl file name> [<mem file>...]\n", argv[0]);
		fprintf(stderr, "Option : -lod <LOD>\n");
		fprintf(stderr, "	  -f <file list>\n");
		fprintf(stderr, "         -thinout <thinout>\n");
		fprintf(stderr, "         -range <maxlat> <minlat> <maxlon> <minlon>\n");
		fprintf(stderr, "         -keep\n");
		exit(1);
	}

	/* IvV */
	lod = "Auto";
	filelist = 0;

	for (narg = 1; narg < argc && argv[narg][0] == '-'; ) {
		if (strcmp(argv[narg], "-lod") == 0) {
			narg++;
			lod = argv[narg++];
		}
		else if (strcmp(argv[narg], "-f") == 0) {
			narg++;
			filelist = argv[narg++];
		}
		else if (strcmp(argv[narg], "-range") == 0) {
			narg++;
			glatmax = atof(argv[narg++]);
			glatmin = atof(argv[narg++]);
			glonmax = atof(argv[narg++]);
			glonmax = atof(argv[narg++]);
			latlon_specified = 1;
		}
		else if (strcmp(argv[narg], "-thinout") == 0) {
			narg++;
			thinout = atoi(argv[narg++]);
		}
		else if (strcmp(argv[narg], "-keep") == 0) {
			narg++;
			keep = 1;
		}
		else {
			fprintf(stderr, "unknown option : %s\n", argv[narg]);
			exit(1);
		}
	}
	if (narg >= argc) {
		fprintf(stderr, "argument error\n");
		exit(1);
	}

	bglfile = argv[narg++];

	/* inf t@CI[v */
	ifp = fopen("dm50.inf", "wb");

	/* e MEM t@C */
	nsrc = 0;

	if (filelist) {
		FILE *ffp;
		char linebuf[100];

		if (!(ffp = fopen(filelist, "r"))) {
			fprintf(stderr, "can't open filelist.\n");
			exit(1);
		}
		    
		while (fgets(linebuf, sizeof(linebuf), ffp)) {
			linebuf[strlen(linebuf)-1] = '\0';
			process_memfile(ifp, linebuf, &nsrc);
		}
		fclose(ffp);
	}

	while (narg < argc) {
		if (strcmp(argv[narg], "--") == 0) {
			/* ňܓxEox͈͂Œ肷 */
			latlon_specified = 1;
		} else {
			process_memfile(ifp, argv[narg], &nsrc);
		}
		narg++;
	}

	/* inf t@C */
	fprintf(ifp, "[Source]\n");
	fprintf(ifp, "Type = MultiSource\n");
	fprintf(ifp, "NumberOfSources = %d\n\n", nsrc);

	fprintf(ifp, "[Destination]\n");
	fprintf(ifp, "LOD                 = %s\n", lod);
	fprintf(ifp, "DestDir             = \".\"\n");
	fprintf(ifp, "DestBaseFileName    = \"dm50\"\n");
	/*fprintf(ifp, "UseSourceDimensions = 1\n");*/
	fprintf(ifp, "NorthLat            = %f\n", glatmax);
	fprintf(ifp, "SouthLat            = %f\n", glatmin);
	fprintf(ifp, "WestLong            = %f\n", glonmin);
	fprintf(ifp, "EastLong            = %f\n", glonmax);

	fclose(ifp);

	/* resample s */
	fprintf(stderr, "\nResampling.....\n");
	if (system("resample.exe dm50.inf") != 0) {
		fprintf(stderr, "resample.exe ̎sG[\n");
		exit(1);
	}

	/* tmfcompress s */
	fprintf(stderr, "\nCompressing.....\n");
	if (system("tmfcompress.exe dm50.tmf dm50c.tmf") != 0) {
		fprintf(stderr, "tmfcompress.exe ̎sG[\n");
		exit(1);
	}

	/* BGL t@C */
	fprintf(stderr, "\nCreate BGL file [%s].....\n", bglfile);
	sprintf(comline, "tmf2bgl.exe dm50c.tmf %s", bglfile);
	if (system(comline) != 0) {
		fprintf(stderr, "tmf2bgl.exe ̎sG[\n");
		exit(1);
	}

	/* svɂȂ raw t@C폜 */
	if (!keep) {
		system("del *.raw");
	}

	fprintf(stderr, "\ndone.\n");
	exit(0);

	return 0;
}

/*
 * MEM t@C
 *
 * file ɂ̓ChJ[hgpł
 */
static void
process_memfile(FILE *ifp, char *file, int *nsrc)
{
	FILE *mfp, *rfp;
	char memfile[MAX_PATH], tmpstr[MAX_PATH], dirname[MAX_PATH], rawfile[MAX_PATH];
	int i;
	WIN32_FIND_DATA fdata;
	HANDLE h;

	/* get dir name */
	strcpy(dirname, file);
	for (i = strlen(dirname) - 1; i > 0; i--) {
		if (dirname[i] == '\\') {
			dirname[i+1] = '\0';
			break;
		}
	}

	/* ChJ[hWĴ߁AFindFirstFile g */
	h = FindFirstFile(file, &fdata);
	if (h == INVALID_HANDLE_VALUE) return;

	do {
		strcpy(memfile, dirname);
		strcat(memfile, fdata.cFileName);

		/* MEM t@CI[v */
		mfp = fopen(memfile, "r");
		if (!mfp) {
			/*fprintf(stderr, "can't open file %s : skip\n", memfile);*/
			continue;
		}
		
		/* raw t@CI[v */
		
		/* remove last '.' */
		strcpy(tmpstr, memfile);
		for (i = strlen(tmpstr) - 1; i > 0; i--) {
			if (tmpstr[i] == '.') {
				tmpstr[i] = '\0';
				break;
			}
		}
		for (; i >= 0; i--) {
			if (tmpstr[i] == ':' || tmpstr[i] == '\\') {
				break;
			}
		}
		i++;
		strcpy(rawfile, &tmpstr[i]);
		strcat(rawfile, ".raw");
		rfp = fopen(rawfile, "wb");
		if (!rfp) {
			fprintf(stderr, "can't open file : %s\n", rawfile);
			exit(1);
		}
		
		/*  & f[^o */
		if (analyze(*nsrc + 1, ifp, mfp, rfp, rawfile) < 0) {
			/* fail... */
		} else {
			(*nsrc)++;
		}
		
		fclose(mfp);
		fclose(rfp);

	} while (FindNextFile(h, &fdata));

	FindClose(h);
}

/*
 * lo
 */
static int
getint(char *buf, int pos1, int pos2)
{
	int i, val;
	int sign = 1;

	val = 0;
	for (i = pos1; i <= pos2; i++) {
		if (buf[i-1] == '-') {
			sign = -1;
		} else {
			val *= 10;
			val += buf[i - 1] - '0';
		}
	}
	val *= sign;

	return val;
}

/*
 * o
 */
static char *
getstr(char *buf, int pos1, int pos2)
{
	char *str;
	int i;

	str = malloc(pos2 - pos1 + 1 + 1);
	for (i = pos1; i <= pos2; i++) {
		str[i - pos1] = buf[i - 1];
	}
	str[i - pos1] = '\0';	/* null terminate */

	return str;
}

/*
 * I7 `xɕϊB
 */
static double
int72deg(int x)
{
	double val;
	int deg, min, sec;

	/* deg */
	deg = x / 10000;
	min = (x / 100) % 100;
	sec = x % 100;

	val = deg + min / 60.0 + sec / 3600.0;
	return val;
}

/*
 * MEM t@C
 */
static int
analyze(int count, FILE *ifp, FILE *mfp, FILE *rfp, char *rawfile)
{
	char linebuf[3000], *desc;
	double latmin, lonmin, latmax, lonmax;
	double latmin1, lonmin1, latmax1, lonmax1;
	double latmin2, lonmin2, latmax2, lonmax2;
	int i, j, h;
	short hh[200][200];

	/* read file header */
	fgets(linebuf, sizeof(linebuf), mfp);
	
	latmin = int72deg(getint(linebuf, 30, 36));
	lonmin = int72deg(getint(linebuf, 37, 43));
	latmax = int72deg(getint(linebuf, 44, 50));
	lonmax = int72deg(getint(linebuf, 51, 57));

	/* convert to WGS-84 */
	latmin1 = latmin2 = latmin;
	latmax1 = latmax2 = latmax;
	lonmin1 = lonmin2 = lonmin;
	lonmax1 = lonmax2 = lonmax;
	
	tko2wgs(&latmax1, &lonmin1);	/* k */
	tko2wgs(&latmax2, &lonmax1);	/* k */
	tko2wgs(&latmin1, &lonmin2);	/* 쐼 */
	tko2wgs(&latmin2, &lonmax2);	/* 쓌 */

	/* NoX̌JȂ悤ɂ邽߂̃}[W */
/*#define	MARGIN	(0.1 / 60.0 / 60.0)*/
#define	MARGIN	0.0
	latmin = (latmin1 + latmin2) / 2.0 - MARGIN;
	latmax = (latmax1 + latmax2) / 2.0 + MARGIN;
	lonmin = (lonmin1 + lonmin2) / 2.0 - MARGIN;
	lonmax = (lonmax1 + lonmax2) / 2.0 + MARGIN;

	if (!latlon_specified) {
		if (latmin < glatmin) glatmin = latmin;
		if (latmax > glatmax) glatmax = latmax;
		if (lonmin < glonmin) glonmin = lonmin;
		if (lonmax > glonmax) glonmax = lonmax;
	}

	/* read desc. */
	desc = getstr(linebuf, 59, 78);
	fprintf(stderr, "[%s]\n", desc);

	/* write inf file */
	fprintf(ifp, "; %s\n", desc);
	free(desc);
	fprintf(ifp, "[Source%d]\n", count);
	fprintf(ifp, "Type              = ElevS16LSB\n");
	fprintf(ifp, "SourceDir         = \".\"\n");
	fprintf(ifp, "SourceFile        = \"%s\"\n", rawfile);
	fprintf(ifp, "CellType          = S16LSB\n");
	/*fprintf(ifp, "NullCellValue     = -9999\n");*/
	fprintf(ifp, "Lat               = %.16f\n", latmax);
	fprintf(ifp, "Lon               = %.16f\n", lonmin);
	fprintf(ifp, "NumOfCellsPerLine = %d\n", 200 / thinout);
	fprintf(ifp, "NumOfLines        = %d\n", 200 / thinout);
	fprintf(ifp, "CellXdimensionDeg = %.16f\n", thinout * (lonmax - lonmin) / 200.0);
	fprintf(ifp, "CellYdimensionDeg = %.16f\n", thinout * (latmax - latmin) / 200.0);
	fprintf(ifp, "ScaleinMeters     = 1.0\n\n");


	/* read rows */
	for (i = 0; i < 200; i++) {
		fgets(linebuf, sizeof(linebuf), mfp);

		/* read columns */
		for (j = 0; j < 200; j++) {
			h = getint(linebuf, 10 + j * 5, 10 + j * 5 + 4);
			if (h == -9999) {
				/* C : 0m ɐݒ肷 */
				h = 0;
			} else {
				/* x␳͂Ȃ */
				h = (h + 5) / 10;	/* convert to meter unit */
			}

			/* write raw file */
			hh[i][j] = (short)h;
#ifdef	BIG_ENDIAN
			hh[i][j] = ((hh[i][j] & 0xff) << 8) | ((hh[i][j] & 0xff00) >> 8);
#endif
		}
	}

	for (i = 0; i < 200; i += thinout) {
		for (j = 0; j < 200; j += thinout) {
			fwrite(&hh[i][j], sizeof(hh[i][j]), 1, rfp);
			/*fprintf(stderr, "[%d]", hh);*/
		}
	}

	return 0;
}
